struct asn1_object_st {
   char const *sn ;
   char const *ln ;
   int nid ;
   int length ;
   unsigned char *data ;
   int flags ;
};
typedef struct asn1_object_st ASN1_OBJECT;
struct asn1_string_st {
   int length ;
   int type ;
   unsigned char *data ;
   long flags ;
};
typedef struct asn1_string_st ASN1_STRING;
typedef struct asn1_string_st ASN1_INTEGER;
typedef struct asn1_string_st ASN1_ENUMERATED;
typedef struct asn1_string_st ASN1_BIT_STRING;
typedef struct asn1_string_st ASN1_OCTET_STRING;
typedef struct asn1_string_st ASN1_PRINTABLESTRING;
typedef struct asn1_string_st ASN1_T61STRING;
typedef struct asn1_string_st ASN1_IA5STRING;
typedef struct asn1_string_st ASN1_GENERALSTRING;
typedef struct asn1_string_st ASN1_UNIVERSALSTRING;
typedef struct asn1_string_st ASN1_BMPSTRING;
typedef struct asn1_string_st ASN1_UTCTIME;
typedef struct asn1_string_st ASN1_GENERALIZEDTIME;
typedef struct asn1_string_st ASN1_VISIBLESTRING;
typedef struct asn1_string_st ASN1_UTF8STRING;
typedef int ASN1_BOOLEAN;
union __anonunion_value_19 {
   char *ptr ;
   ASN1_BOOLEAN boolean ;
   ASN1_STRING *asn1_string ;
   ASN1_OBJECT *object ;
   ASN1_INTEGER *integer ;
   ASN1_ENUMERATED *enumerated ;
   ASN1_BIT_STRING *bit_string ;
   ASN1_OCTET_STRING *octet_string ;
   ASN1_PRINTABLESTRING *printablestring ;
   ASN1_T61STRING *t61string ;
   ASN1_IA5STRING *ia5string ;
   ASN1_GENERALSTRING *generalstring ;
   ASN1_BMPSTRING *bmpstring ;
   ASN1_UNIVERSALSTRING *universalstring ;
   ASN1_UTCTIME *utctime ;
   ASN1_GENERALIZEDTIME *generalizedtime ;
   ASN1_VISIBLESTRING *visiblestring ;
   ASN1_UTF8STRING *utf8string ;
   ASN1_STRING *set ;
   ASN1_STRING *sequence ;
};
struct asn1_type_st {
   int type ;
   union __anonunion_value_19 value ;
};
typedef struct asn1_type_st ASN1_TYPE;
typedef unsigned char des_cblock[8];
union __anonunion_ks_23 {
   des_cblock cblock ;
   unsigned long deslong[2] ;
};
struct des_ks_struct {
   union __anonunion_ks_23 ks ;
   int weak_key ;
};
typedef struct des_ks_struct des_key_schedule[16];
struct rc4_key_st {
   unsigned int x ;
   unsigned int y ;
   unsigned int data[256] ;
};
typedef struct rc4_key_st RC4_KEY;
struct rc2_key_st {
   unsigned int data[64] ;
};
typedef struct rc2_key_st RC2_KEY;
struct rc5_key_st {
   int rounds ;
   unsigned long data[34] ;
};
typedef struct rc5_key_st RC5_32_KEY;
struct bf_key_st {
   unsigned int P[18] ;
   unsigned int S[1024] ;
};
typedef struct bf_key_st BF_KEY;
struct cast_key_st {
   unsigned long data[32] ;
   int short_key ;
};
typedef struct cast_key_st CAST_KEY;
struct idea_key_st {
   unsigned int data[9][6] ;
};
typedef struct idea_key_st IDEA_KEY_SCHEDULE;
struct env_md_st {
   int type ;
   int pkey_type ;
   int md_size ;
   void (*init)() ;
   void (*update)() ;
   void (*final)() ;
   int (*sign)() ;
   int (*verify)() ;
   int required_pkey_type[5] ;
   int block_size ;
   int ctx_size ;
};
typedef struct env_md_st EVP_MD;
struct evp_cipher_st;typedef struct evp_cipher_st EVP_CIPHER;
struct evp_cipher_ctx_st;typedef struct evp_cipher_ctx_st EVP_CIPHER_CTX;
struct evp_cipher_st {
   int nid ;
   int block_size ;
   int key_len ;
   int iv_len ;
   unsigned long flags ;
   int (*init)(EVP_CIPHER_CTX *ctx , unsigned char const *key , unsigned char const *iv ,
               int enc ) ;
   int (*do_cipher)(EVP_CIPHER_CTX *ctx , unsigned char *out , unsigned char const *in ,
                    unsigned int inl ) ;
   int (*cleanup)(EVP_CIPHER_CTX * ) ;
   int ctx_size ;
   int (*set_asn1_parameters)(EVP_CIPHER_CTX * , ASN1_TYPE * ) ;
   int (*get_asn1_parameters)(EVP_CIPHER_CTX * , ASN1_TYPE * ) ;
   int (*ctrl)(EVP_CIPHER_CTX * , int type , int arg , void *ptr ) ;
   void *app_data ;
};
struct __anonstruct_rc4_27 {
   unsigned char key[16] ;
   RC4_KEY ks ;
};
struct __anonstruct_desx_cbc_28 {
   des_key_schedule ks ;
   des_cblock inw ;
   des_cblock outw ;
};
struct __anonstruct_des_ede_29 {
   des_key_schedule ks1 ;
   des_key_schedule ks2 ;
   des_key_schedule ks3 ;
};
struct __anonstruct_rc2_30 {
   int key_bits ;
   RC2_KEY ks ;
};
struct __anonstruct_rc5_31 {
   int rounds ;
   RC5_32_KEY ks ;
};
union __anonunion_c_26 {
   struct __anonstruct_rc4_27 rc4 ;
   des_key_schedule des_ks ;
   struct __anonstruct_desx_cbc_28 desx_cbc ;
   struct __anonstruct_des_ede_29 des_ede ;
   IDEA_KEY_SCHEDULE idea_ks ;
   struct __anonstruct_rc2_30 rc2 ;
   struct __anonstruct_rc5_31 rc5 ;
   BF_KEY bf_ks ;
   CAST_KEY cast_ks ;
};
struct evp_cipher_ctx_st {
   EVP_CIPHER const *cipher ;
   int encrypt ;
   int buf_len ;
   unsigned char oiv[8] ;
   unsigned char iv[8] ;
   unsigned char buf[8] ;
   int num ;
   void *app_data ;
   int key_len ;
   union __anonunion_c_26 c ;
};
extern int OBJ_NAME_add(char const *name , int type , char const *data ) ;
extern EVP_MD *EVP_md2(void) ;
extern EVP_MD *EVP_md5(void) ;
extern EVP_MD *EVP_sha1(void) ;
extern EVP_MD *EVP_dss1(void) ;
extern EVP_CIPHER *EVP_des_cbc(void) ;
extern EVP_CIPHER *EVP_des_ede3_cbc(void) ;
extern EVP_CIPHER *EVP_rc4(void) ;
extern EVP_CIPHER *EVP_idea_cbc(void) ;
extern EVP_CIPHER *EVP_rc2_cbc(void) ;
extern int EVP_add_cipher(EVP_CIPHER *cipher ) ;
extern int EVP_add_digest(EVP_MD *digest ) ;
int SSL_library_init(void) ;
int SSL_library_init(void)
{ EVP_CIPHER *tmp ;
  EVP_CIPHER *tmp___0 ;
  EVP_CIPHER *tmp___1 ;
  EVP_CIPHER *tmp___2 ;
  EVP_CIPHER *tmp___3 ;
  EVP_MD *tmp___4 ;
  EVP_MD *tmp___5 ;
  EVP_MD *tmp___6 ;
  EVP_MD *tmp___7 ;
  {
  tmp = EVP_des_cbc(); EVP_add_cipher(tmp);
  tmp___0 = EVP_des_ede3_cbc(); EVP_add_cipher(tmp___0);
  tmp___1 = EVP_idea_cbc(); EVP_add_cipher(tmp___1);
  tmp___2 = EVP_rc4(); EVP_add_cipher(tmp___2);
  tmp___3 = EVP_rc2_cbc(); EVP_add_cipher(tmp___3);
  tmp___4 = EVP_md2(); EVP_add_digest(tmp___4);
  tmp___5 = EVP_md5(); EVP_add_digest(tmp___5);
  OBJ_NAME_add((char const *)"ssl2-md5", 32769, (char const *)"MD5");
  OBJ_NAME_add((char const *)"ssl3-md5", 32769, (char const *)"MD5");
  tmp___6 = EVP_sha1(); EVP_add_digest(tmp___6);
  OBJ_NAME_add((char const *)"ssl3-sha1", 32769, (char const *)"SHA1");
  OBJ_NAME_add((char const *)"RSA-SHA1-2", 32769, (char const *)"RSA-SHA1");
  tmp___7 = EVP_dss1(); EVP_add_digest(tmp___7);
  OBJ_NAME_add((char const *)"DSA-SHA1-old", 32769, (char const *)"DSA-SHA1");
  OBJ_NAME_add((char const *)"DSS1", 32769, (char const *)"DSA-SHA1");
  OBJ_NAME_add((char const *)"dss1", 32769, (char const *)"DSA-SHA1");
  return (1);
}
}
