/**************************** CPPHeaderFile ***************************

* FileName [IdCollector.h]

* PackageName [main]

* Synopsis [Header file for IdCollector class.]

* Description [This class encapsulates a AST walker that computes the
* set of identifiers in an expression.]

* SeeAlso [IdCollector.cpp]

* Author [Sagar Chaki]

* Copyright [ Copyright (c) 2002 by Carnegie Mellon University.  All
* Rights Reserved. This software is for educational purposes only.
* Permission is given to academic institutions to use, copy, and
* modify this software and its documentation provided that this
* introductory message is not removed, that this software and its
* documentation is used for the institutions' internal research and
* educational purposes, and that no monies are exchanged. No guarantee
* is expressed or implied by the distribution of this code. Send
* bug-reports and/or questions to: chaki+@cs.cmu.edu. ]

**********************************************************************/

#ifndef __IDCOLLECTOR_H__
#define __IDCOLLECTOR_H__

class IdCollector : public DFSAdapter
{
 private:
  set<string> ids;

 public:
  IdCollector() {}
  virtual ~IdCollector() {}
  set<string> GetIds() const { return ids; }

  //overridden methods
  void outIdExpr(const IdExpr &node);
  void outDotExpr(const DotExpr &node);
  void outArrowExpr(const ArrowExpr &node);
};

#endif //__IDCOLLECTOR_H__

/*********************************************************************/
//end of IdCollector.h
/*********************************************************************/
