/**************************** CPPHeaderFile ***************************

* FileName [LtlChecker.h]

* PackageName [main]

* Synopsis [Header file for LtlChecker class.]

* Description [This class encapsulates a model checker for LTL
* formulas.]

* SeeAlso [LtlChecker.cpp]

* Author [Sagar Chaki]

* Copyright [ Copyright (c) 2002 by Carnegie Mellon University.  All
* Rights Reserved. This software is for educational purposes only.
* Permission is given to academic institutions to use, copy, and
* modify this software and its documentation provided that this
* introductory message is not removed, that this software and its
* documentation is used for the institutions' internal research and
* educational purposes, and that no monies are exchanged. No guarantee
* is expressed or implied by the distribution of this code. Send
* bug-reports and/or questions to: chaki+@cs.cmu.edu. ]

**********************************************************************/

#ifndef __LTLCHECKER_H__
#define __LTLCHECKER_H__

class LtlChecker
{
 private:
  static size_t ssn;
  static set<int> visited1;
  static set<int> visited2;
  static set<int> stack;
  static list<int> statePath;
  static list<Action> actPath;
  static bool violation;

  static bool PropCompatible(int implState,int specState);
  static bool ActCompatible(const Action &act,int specState);
  static void DFS1(const int node);
  static void DFS2(const int node);

 public:
  static bool CheckFormula();
  
  friend class GlobalCEDag;
};

#endif //__LTLCHECKER_H__

/*********************************************************************/
//end of LtlChecker.h
/*********************************************************************/
