/**************************** CPPHeaderFile ***************************

* FileName [AGChecker.h]

* PackageName [main]

* Synopsis [Header file for AGChecker class.]

* Description [This class encapsulates a checker that verifies the
* reachability of the ERROR state using Assume-Guarantee reasoning and
* Angluin style DFA learning.]

* SeeAlso [AGChecker.cpp]

* Author [Sagar Chaki]

* Copyright [ Copyright (c) 2002 by Carnegie Mellon University.  All
* Rights Reserved. This software is for educational purposes only.
* Permission is given to academic institutions to use, copy, and
* modify this software and its documentation provided that this
* introductory message is not removed, that this software and its
* documentation is used for the institutions' internal research and
* educational purposes, and that no monies are exchanged. No guarantee
* is expressed or implied by the distribution of this code. Send
* bug-reports and/or questions to: chaki+@cs.cmu.edu. ]

**********************************************************************/

#ifndef __AGCHECKER_H__
#define __AGCHECKER_H__

namespace magic {

class AGChecker
{
 public:
  static bool Run();
};

} //namespace magic

#endif //__AGCHECKER_H__

/*********************************************************************/
//end of AGChecker.h
/*********************************************************************/
